//============================================================================
//	apci8132w.pas
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.11 Date 1999/07/15
//
//============================================================================

unit apci8132w;

interface

uses
	Windows;

//-------------------------------------
// װޒ萔
//-------------------------------------
const
	APCI8132_SUCCESS							= 0;	// I
	APCI8132_ERR_SYSTEM						= 1;	// GetLastError sĂ
	APCI8132_ERR_NO_DEVICE				= 2;	// gp\޲Ȃ
	APCI8132_ERR_IN_USE						= 3;	// w肳ꂽ޲͎gp
	APCI8132_ERR_INVALID_SLOT			= 4;	// Ș_ۯĔԍw肵
	APCI8132_ERR_RESOURCE					= 5;	// ؿװ
	APCI8132_ERR_INVALID_PORT			= 6;	// ȃ|[gv
	APCI8132_ERR_INVALID_ARGUMENT	= 7;	// Ȉv
	APCI8132_ERR_NO_CREATE				= 8;	// ޲شĂĂ܂
	APCI8132_ERR_WRAPDLL					=Dword(-1);	// ׯ߰֐װ
//-------------------------------------
// ߰Ĕԍ萔
//-------------------------------------
	APCI8132_PORT_1 = 0;
	APCI8132_PORT_2 = 1;
	APCI8132_PORT_3 = 2;
	APCI8132_PORT_4 = 3;
	APCI8132_PORT_5 = 4;
	APCI8132_PORT_6 = 5;
	APCI8132_PORT_7 = 6;
	APCI8132_PORT_8 = 7;
//-------------------------------------
// ̑萔
//-------------------------------------
	APCI8132_DLL_NAME 	= 'apci8132.dll';	// DLĻٖ
	APCI8132_MAX_PORTS	= 8;							// ߰Đ
	APCI8132_MAX_SLOTS	= 16;							// őۯĐ
	APCI8132_DEVICE_ID	= $136c8132;			// ޲ID
	APCI8132_SLOT_AUTO	= $ffff;					// AutoSlotl
//-------------------------------------
// ؿ\
//-------------------------------------
	APCI8132_MAX_MEM	=	 9;
	APCI8132_MAX_IO		= 20;
	APCI8132_MAX_IRQ	=	 7;
	APCI8132_MAX_DMA	=	 7;

type
	TAPCI8132RESOURCE = record
		dwNumMemWindows:																	DWORD;	// س޳(gp)
		dwMemBase:			array [1 .. APCI8132_MAX_MEM] of	DWORD;	// س޳ްڽ(gp)
		dwMemLength:		array [1 .. APCI8132_MAX_MEM] of	DWORD;	// س޳(gp)
		dwMemAttrib:		array [1 .. APCI8132_MAX_MEM] of	DWORD;	// س޳(gp)
		dwNumIOPorts:																			DWORD;	// I/O߰Đ
		dwIOPortBase:		array [1 .. APCI8132_MAX_IO] of		DWORD;	// I/O߰ްڽ
		dwIOPortLength: array [1 .. APCI8132_MAX_IO] of		DWORD;	// I/O߰Ē
		dwNumIRQs:																				DWORD;	// IRQ(gp)
		dwIRQRegisters: array [1 .. APCI8132_MAX_IRQ] of	DWORD;	// IRQؽ(gp)
		dwIRQAttrib:		array [1 .. APCI8132_MAX_IRQ] of	DWORD;	// IRQؽ(gp)
		dwNumDMAs:																				DWORD;	// DMAِ(gp)
		dwDMALst:				array [1 .. APCI8132_MAX_DMA] of	DWORD;	// DMAؽ(gp)
		dwDMAAttrib:		array [1 .. APCI8132_MAX_DMA] of	DWORD;	// DMAّؽ(gp)
		dwReserved1:		array [1 .. 3] of									DWORD;	// \(gp)
	end;
//-------------------------------------
// J֐
//-------------------------------------
// DLL ۰
function Apci8132wDllOpen: Boolean;
// DLL ۰
function Apci8132wDllClose: Boolean;
// aPCI-8132 DLL,޲ײްްޮݔԍ擾
function Apci8132wGetVersion(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): Boolean;
// CӂaPCI-8132̎gp錾
function Apci8132wCreate(var pwLogSlot:WORD): Boolean;
// CӂaPCI-8132̎gpJ
function Apci8132wClose(wLogSlot:WORD): Boolean;
// ؿ擾
function Apci8132wGetResource(wLogSlot:WORD; var pResInfo:TAPCI8132RESOURCE): Boolean;
// Cӂ߰Ăް
function Apci8132wInPort(wLogSlot:WORD; dwLogPort:DWORD; var pbInValue:BYTE): Boolean;
// aPCI-8132̴װ
function Apci8132wGetLastError(wLogSlot:WORD): DWORD;
// ۰ذ̒l擾
function Apci8132wGetSwitchValue(wLogSlot:WORD; var pdwSwitchValue:DWORD): Boolean;

//-------------------------------------
// (STATIC)ϐȂ
//-------------------------------------
implementation

{$J+}	// ^t萔̕ύX\߲׎w
const
	hDLL: THandle = 0;

type
	TApci8132GetVersion = function(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): BOOL; stdcall;
	TApci8132Create = function(var pwLogSlot:WORD): BOOL; stdcall;
	TApci8132Close = function(wLogSlot:WORD): BOOL; stdcall;
	TApci8132GetResource = function(wLogSlot:WORD; var pres:TAPCI8132RESOURCE): BOOL; stdcall;
	TApci8132InPort = function(wLogSlot:WORD; dwLogPort:DWORD; var pbInValue:BYTE): BOOL; stdcall;
	TApci8132GetLastError = function(wLogSlot:WORD): DWORD; stdcall;
	TApci8132GetSwitchValue = function(wLogSlot:WORD; var pdwSwitchValue:DWORD): BOOL; stdcall;

// DLL ߰Ċ֐ڽ̊i[ϐ
var
	pApci8132GetVersion: TApci8132GetVersion;
	pApci8132Create: TApci8132Create;
	pApci8132Close: TApci8132Close;
	pApci8132GetResource: TApci8132GetResource;
	pApci8132InPort: TApci8132InPort;
	pApci8132GetLastError: TApci8132GetLastError;
	pApci8132GetSwitchValue: TApci8132GetSwitchValue;

function Apci8132wGetDllExportFunc: Boolean; forward;

{$J-}

//============================================================================
// 		apci8132.dll۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//============================================================================
function Apci8132wDllOpen: Boolean;
begin
	Result := False;
	if hDLL = 0 then begin
		hDLL := LoadLibrary(APCI8132_DLL_NAME);
		if hDLL <> 0 then begin
			Result := Apci8132wGetDllExportFunc;
			if Result <> True then
				Apci8132wDllClose;		// DLL֐擾ɎŝDLL۰
		end;
	end;
end;
//============================================================================
// 		apci8132.dll۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//============================================================================
function Apci8132wDllClose: Boolean;
begin
	Result := False;
	if hDLL <> 0 then begin
		Result := FreeLibrary(hDLL);
		if Result = True then begin
			hDLL := 0;
		end;
	end;
end;
//============================================================================
// 		aPCI-8132 DLL,޲ײްްޮݔԍ擾
// 		pdwDllVersion			DLLްޮݔԍi[̈ւ߲
//				pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Apci8132wGetVersion(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci8132GetVersion(pdwDllVersion, pdwDriverVersion);
end;
//============================================================================
// 		aPCI-8132̔Cӂ޲̎gp錾
// 		pwLogSlot	 gp޲̘_ۯĔԍi[߲
// ߂l  True
//				s False
//============================================================================
function Apci8132wCreate(var pwLogSlot:WORD): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci8132Create(pwLogSlot)
end;
//============================================================================
// 		aPCI-8132̔Cӂ޲̎gpJ
// 		wLogSlot ޲̘_ۯĔԍ
// ߂l  True
//				s False
//============================================================================
function Apci8132wClose(wLogSlot:WORD): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci8132Close(wLogSlot)
end;
//============================================================================
// 		w޲ؿ擾
// 		wLogSlot	ؿ擾޲̘_ۯĔԍ
//				pResInfo	ؿi[\߲̂
// ߂l  True
//				s False
//============================================================================
function Apci8132wGetResource(wLogSlot:WORD; var pResInfo:TAPCI8132RESOURCE): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci8132GetResource(wLogSlot, pResInfo)
end;
//============================================================================
// 		Cӂ߰Ăް
// 		wLogSlot	͂޲̘_ۯĔԍ
//				dwLogPort	͂_߰
//				pbInValue ްi[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Apci8132wInPort(wLogSlot:WORD; dwLogPort:DWORD; var pbInValue:BYTE): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci8132InPort(wLogSlot, dwLogPort, pbInValue)
end;
//============================================================================
// 		aPCI-8132̴װ
// 		wLogSlot	װ޲̘_ۯĔԍ
// ߂l װ
//============================================================================
function Apci8132wGetLastError(wLogSlot:WORD): DWORD;
begin
	if hDLL = 0 then Result := APCI8132_ERR_WRAPDLL
	else Result := pApci8132GetLastError(wLogSlot)
end;
//============================================================================
// 		۰ذ̒l擾
// 		wLogSlot				۰ذ̒l擾޲̘_ۯĔԍ
// 				pdwSwitchValue	۰ذ̒li[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Apci8132wGetSwitchValue(wLogSlot:WORD; var pdwSwitchValue:DWORD): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci8132GetSwitchValue(wLogSlot, pdwSwitchValue)
end;
//---------------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  True
//		  	s False
//---------------------------------------------------------------------------
function Apci8132wGetDllExportFunc: Boolean;
begin
	Result := False;
	// Apci8132GetVersion ̱ڽ擾
	pApci8132GetVersion := GetProcAddress(hDLL, 'Apci8132GetVersion');
	if @pApci8132GetVersion = nil then Exit;
	// Apci8132Create ̱ڽ擾
	pApci8132Create := GetProcAddress(hDLL, 'Apci8132Create');
	if @pApci8132Create = nil then Exit;
	// Apci8132Close ̱ڽ擾
	pApci8132Close := GetProcAddress(hDLL, 'Apci8132Close');
	if @pApci8132Close = nil then Exit;
	// Apci8132GetResource ̱ڽ擾
	pApci8132GetResource := GetProcAddress(hDLL, 'Apci8132GetResource');
	if @pApci8132GetResource = nil then Exit;
	// Apci8132InPort ̱ڽ擾
	pApci8132InPort := GetProcAddress(hDLL, 'Apci8132InPort');
	if @pApci8132InPort = nil then Exit;
	// Apci8132GetLastError ̱ڽ擾
	pApci8132GetLastError := GetProcAddress(hDLL, 'Apci8132GetLastError');
	if @pApci8132GetLastError = nil then Exit;
	// Apci8132GetSwitchValue ̱ڽ擾
	pApci8132GetSwitchValue := GetProcAddress(hDLL, 'Apci8132GetSwitchValue');
	if @pApci8132GetSwitchValue = nil then Exit;
	// SĂ DLL ߰Ċ֐ڽ擾nj
	Result := True;
end;

end.

